--- a/netcat.c
+++ b/netcat.c
@@ -39,7 +39,7 @@
 /* conditional includes -- a very messy section which you may have to dink
    for your own architecture [and please send diffs...]: */
 /* #undef _POSIX_SOURCE		/* might need this for something? */
-#define HAVE_BIND		/* ASSUMPTION -- seems to work everywhere! */
+#undef HAVE_BIND		/* ASSUMPTION -- seems to work everywhere! */
 #define HAVE_HELP		/* undefine if you dont want the help text */
 /* #define ANAL			/* if you want case-sensitive DNS matching */
 
@@ -56,7 +56,7 @@
 #ifdef FD_SETSIZE		/* should be in types.h, butcha never know. */
 #undef FD_SETSIZE		/* if we ever need more than 16 active */
 #endif				/* fd's, something is horribly wrong! */
-#define FD_SETSIZE 16		/* <-- this'll give us a long anyways, wtf */
+#define FD_SETSIZE 1024		/* <-- this'll give us a long anyways, wtf */
 #include <sys/types.h>		/* *now* do it.  Sigh, this is broken */
 
 #ifdef HAVE_RANDOM		/* aficionados of ?rand48() should realize */
@@ -81,8 +81,10 @@
 #include <errno.h>
 #include <signal.h>
 #include <fcntl.h>		/* O_WRONLY et al */
+#include <unistd.h>		/* alarm() close() sleep() */
+#include <time.h>		/* time() */
 
-#ifdef LINUX
+#ifdef __linux__
 #include <resolv.h>
 #endif
 
--- a/generic.h
+++ b/generic.h
@@ -274,7 +274,7 @@
 
 /* linux, which is trying as desperately as the gnu folks can to be
    POSIXLY_CORRECT.  I think I'm gonna hurl... */
-#ifdef LINUX
+#ifdef __linux__
 #undef UTMPX
 #undef HAVE_SYSINFO
 #undef HAVE_SELECT_H
@@ -373,3 +373,4 @@
 /* ================ */
 #endif /* GENERIC_H */
 
+#define arm arm_timer
